/* --------------------------------------------------------------------------
	Project S.W.O.R.D
	V2.10

	SubSystem  : Little usefull graphical objects
	CommandNos : 3300..3399
	File       : Include/Gadgets/IntLift.H
	Author     : Eric NICOLAS
	Overview   : TIntegerLift object
	UpDate     : Apr 08, 1996

** Copyright (C) 1993-1996 Eric NICOLAS
**
** This file is distributed under the terms listed in the document
** "copying.en". A copy of "copying.en" should accompany this file.
** if not, a copy should be available from where this file was obtained.
** This file may not be distributed without a verbatim copy of "copying.en".
**
** This file is distributed WITHOUT ANY WARRANTY; without even the implied
** warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
** ------------------------------------------------------------------------*/

#ifndef _GADGETS_INTLIFT_H_
#define _GADGETS_INTLIFT_H_

class TIntegerLift;

#define cmIntegerLiftUp                3300
#define cmIntegerLiftDown              3301

// --- TIntegerLift  object

extern short RegTIntegerLift;
extern char *IdentTIntegerLift;

class TIntegerLift : public TZone
{ DECLARE(TIntegerLift);
  DECLARE_EVENTS_TABLE;
  // --- Datas
  protected:
    TEditInteger *Edit;
    TStdButton   *Up, *Down;
    long          Min, Max;
  // --- Functions
  public:
  // Public constructors
			 TIntegerLift(void);
			 TIntegerLift(TEditInteger *_Edit, long _Min, long _Max);
  // Creation / Destruction
          void     Defaults(void);
			 void     Init(TEditInteger *_Edit, long _Min, long _Max);
  // Events handling
          boolean  doIntegerLiftUp(void);
          boolean  doIntegerLiftDown(void);
};

#endif // _GADGETS_INTLIFT_H_

/* --------------------------------------------------------------------------
** HISTORY
** --------------------------------------------------------------------------
** 2.10:
**   21/02/96 :EN: First History remark. Copying code V2.00->V2.10
**   29/02/96 :EN: Moving from struct to class. Adding Defaults() method
**   01/04/96 :EN: Adding DECLARE_COMMAND... macros
**   03/04/96 :EN: Number of bug-fix made
**   08/04/96 :EN: Changing from DECLARE_COMMAND... to DECLARE_EVENTS...
** ------------------------------------------------------------------------*/
