/* --------------------------------------------------------------------------
   Project S.W.O.R.D
   V2.0

   SubSystem : Screen graphics management
   File      : Include/Graphics/Graphics.H
   ErrNos    : 2000..2099
   Author    : Eric NICOLAS
   Overview  : Init / Done of the module Graphics
   UpDate    : Mar 13, 1996

** Copyright (C) 1993-1996 The SWORD Group
**
** This file is distributed under the terms listed in the document
** "copying.en". A copy of "copying.en" should accompany this file.
** if not, a copy should be available from where this file was obtained.
** This file may not be distributed without a verbatim copy of "copying.en".
**
** This file is distributed WITHOUT ANY WARRANTY; without even the implied
** warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
** ------------------------------------------------------------------------*/

#ifndef _GRAPHICS_GRAPHICS_H_
#define _GRAPHICS_GRAPHICS_H_

#include "graphics/grx.h"
#include "graphics/fontsys.h"
#include "graphics/colors.h"
#include "graphics/scrzone.h"
#include "graphics/zone.h"
#include "graphics/desktop.h"
#include "graphics/window.h"
#include "graphics/shell.h"
#include "graphics/mapping.h"
#include "graphics/drawings.h"

// Error Nos

#define erNoMouseDetected     2000

// Functions

void InitGraphics(void);
void DoneGraphics(void);

#endif // _GRAPHICS_GRAPHICS_H_

/* --------------------------------------------------------------------------
** HISTORY
** --------------------------------------------------------------------------
** 2.10:
**   20/02/96 :EN: First History remark. Copying code V2.00->V2.10
**   28/02/96 :EN: Bug in mouse cursor aspect with djgppV2 corrected.
**   13/03/96 :EN: Moving Ending Message do Basic/BASIC.CC
** ------------------------------------------------------------------------*/
