/* --------------------------------------------------------------------------
	Project S.W.O.R.D
	V2.10

	SubSystem : Quite sofisticated tools
	File      : Include/Tools/Phases.H
	Author    : Eric NICOLAS
	Overview  : Execution phases trace
	UpDate    : Mar 02, 1996

** Copyright (C) 1993-1996 The SWORD Group
**
** This file is distributed under the terms listed in the document
** "copying.en". A copy of "copying.en" should accompany this file.
** if not, a copy should be available from where this file was obtained.
** This file may not be distributed without a verbatim copy of "copying.en".
**
** This file is distributed WITHOUT ANY WARRANTY; without even the implied
** warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
** ------------------------------------------------------------------------*/

#ifndef _TOOLS_PHASES_H_
#define _TOOLS_PHASES_H_

class TPhaseWindow;

// TPhaseWindow : Show an execution phase

extern short RegTPhaseWindow;
extern char *IdentTPhaseWindow;

class TPhaseWindow : public TToolWindow
{ DECLARE(TPhaseWindow);
  // --- Datas
  protected:
    TGauge *Gauge;
  // --- Functions
  public:
  // Public constructor
           TPhaseWindow(void);
           TPhaseWindow(char *Name);
  // Construction / Destruction
           void Defaults(void);
           void Init(char *Name);
  //
           void  SetValue(int V);
};

// Execution phases gestion

void BeginPhase(char *Title);
void AvancePhase(int Avance);
void EndPhase(void);

// Execution phases gestion Init/Done

void InitPhases(void);
void DonePhases(void);
void ActivateGraphicPhases(void);

#endif // _TOOLS_PHASES_H_

/* --------------------------------------------------------------------------
** HISTORY
** --------------------------------------------------------------------------
** 2.10:
**   21/02/96 :EN: First History remark. Copying code V2.00->V2.10
**   28/02/96 :EN: No graphic phases before desktop created
**   02/03/96 :EN: Moving from struct to class. Adding Defaults() method.
** ------------------------------------------------------------------------*/
