#ifndef __serio_h
#define __serio_h

#ifdef __cplusplus
extern "C" {
#endif

enum sioWordSize {
	sio5Bits,
	sio6Bits,
	sio7Bits,
	sio8Bits,
};

enum sioParity {
	sioNoParity		=0x00,
	sioOddParity	=0x08,
	sioEvenParity	=0x18,
	sioMarkParity	=0x28,
	sioSpaceParity	=0x38,
};

enum sioStopBits {
	sio1StopBit=0x00,
	sio1_5StopBits=0x04,
	sio2StopBits=0x04,
};

int  sio_put(char characterToSend); /* 0=success, 1=buffer full */
int  sio_charready(void);			/* 1 if chars avail, 0 if nothing there */
int  sio_get(void);					/* -1 if break detected, char otherwise */
void sio_sendbreak(int charactersToHoldBreak);
void sio_setspeed(int baudRateDivisor);	/* does not convert from baud */
int  sio_getspeed(void);			/* does not convert to baud */
void sio_setmcr(int valueToSetModemControlRegisterTo);
int  sio_getmcr(void);
void sio_setlcr(int valueToSetLineControlRegisterTo);
int  sio_getlcr(void);
void sio_setparms(enum sioWordSize, enum sioParity, enum sioStopBits);
int  sio_init(int baseAddress, int hardwareInterruptRequestNumber);
int  sio_uninit(void);

extern volatile int sio_error;		/* a reveive error has occured */
extern volatile int sio_errct;		/* number of receive errors */
extern volatile char sio_break;		/* a break has been detected */
extern volatile char sio_linestat;	/* current line status */
extern volatile char sio_modemstat;	/* current modem status */
extern char sio_doxoff;				/* enable s/w flow control */
extern char sio_brkmode;			/* enable break detection */

#ifdef __cplusplus
}
#endif

#endif __serio_h
